#include <opnet.h>
#include <ema.h>
#include <opnet_emadefs.h>
#include <opnet_constants.h>



/* array for all textlist attributes in model */
Prg_List*		prg_lptr [17];

/* array for all objects in model */
EmaT_Object_Id		obj [42];



main (int argc, char* argv [])
	{
	EmaT_Model_Id			model_id;
	int					i;

	/* initialize EMA package */
	Ema_Init (EMAC_MODE_ERR_PRINT, argc, argv);

	/* create an empty model */
	model_id = Ema_Model_Create (MOD_PROCESS);



	/* create all objects */
	obj [0] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [1] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [2] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [3] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [4] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [5] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [6] = Ema_Object_Create (model_id, OBJ_PR_ATTR_ASSGN);
	obj [7] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [8] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [9] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [10] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [11] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [12] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [13] = Ema_Object_Create (model_id, OBJ_PR_STATE);
	obj [14] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [15] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [16] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [17] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [18] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [19] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [20] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [21] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [22] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [23] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [24] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [25] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [26] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [27] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [28] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [29] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [30] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [31] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [32] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [33] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [34] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [35] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [36] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [37] = Ema_Object_Create (model_id, OBJ_PR_TRANS);
	obj [38] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [39] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [40] = Ema_Object_Create (model_id, OBJ_PR_POS);
	obj [41] = Ema_Object_Create (model_id, OBJ_PR_POS);




	/* set the model level attributes */
	/* create and init prg list 'prg_lptr [0]' */
	prg_lptr [0] = prg_list_create ();
	/* create and init prg list 'prg_lptr [1]' */
	prg_lptr [1] = prg_list_create ();
	prg_list_strings_append (prg_lptr [1], 
		"List*	event_list_ptr;",
		"List*	line_list_ptr;",
		"int		i,list_size;",
		"Vartype*	string,field0,field2;",
		"List*	field_list_ptr;",
		"Script_Inst*	inst_ptr;",
		"Vartype*	script_name;",
		"int object_id;",
		PRGC_NIL);

	/* create and init prg list 'prg_lptr [2]' */
	prg_lptr [2] = prg_list_create ();
	prg_list_strings_append (prg_lptr [2], 
		"/*",
		"#define ARRIVAL (op_intrpt_type () == OPC_INTRPT_STRM);",
		"*/",
		"#define ARRIVAL 5",
		"#define FAIL_CODE 1",
		"#define RECOVER_CODE 0",
		"typedef struct {",
		"  float time;",
		"  int user_id;",
		"  int type;",
		"} Script_Inst;",
		PRGC_NIL);

	/* create and init prg list 'prg_lptr [3]' */
	prg_lptr [3] = prg_list_create ();
	/* create and init prg list 'prg_lptr [4]' */
	prg_lptr [4] = prg_list_create ();
	/* create and init prg list 'prg_lptr [5]' */
	prg_lptr [5] = prg_list_create ();
	/* create and init prg list 'prg_lptr [6]' */
	prg_lptr [6] = prg_list_create ();
	/* create and init prg list 'prg_lptr [7]' */
	prg_lptr [7] = prg_list_create ();
	prg_list_strings_append (prg_lptr [7], 
		"Must have recovery and failure interupts enabled and also\n",
		"the initial value set in network wide because we are using\n",
		"a centralized proccess ",
		PRGC_NIL);

	/* create and init prg list 'prg_lptr [8]' */
	prg_lptr [8] = prg_list_create ();
	Ema_Model_Attr_Set (model_id,
		"state vars",           COMP_CONTENTS, prg_lptr [0],
		"temp vars",            COMP_CONTENTS, prg_lptr [1],
		"header block",         COMP_CONTENTS, prg_lptr [2],
		"function block",       COMP_CONTENTS, prg_lptr [3],
		"diag block",           COMP_CONTENTS, prg_lptr [4],
		"termination block",    COMP_CONTENTS, prg_lptr [5],
		"global stat descs",    COMP_INTENDED, EMAC_DISABLED,
		"local stat descs",     COMP_INTENDED, EMAC_DISABLED,
		"child processes",      COMP_CONTENTS, prg_lptr [6],
		"model comments",       COMP_CONTENTS, prg_lptr [7],
		"ext fileset",          COMP_CONTENTS, prg_lptr [8],
		"interface descriptions",COMP_INTENDED, EMAC_DISABLED,
		"attribute assignments",COMP_ARRAY_CONTENTS (0), obj [0],
		"attribute assignments",COMP_ARRAY_CONTENTS (1), obj [1],
		"attribute assignments",COMP_ARRAY_CONTENTS (2), obj [2],
		"attribute assignments",COMP_ARRAY_CONTENTS (3), obj [3],
		EMAC_EOL);

	Ema_Model_Attr_Set (model_id,
		"attribute assignments",COMP_ARRAY_CONTENTS (4), obj [4],
		"attribute assignments",COMP_ARRAY_CONTENTS (5), obj [5],
		"attribute assignments",COMP_ARRAY_CONTENTS (6), obj [6],
		"simulation attributes",COMP_INTENDED, EMAC_DISABLED,
		EMAC_EOL);



	/* assign attrs for object 'obj [7]' */
	/* create and init prg list 'prg_lptr [9]' */
	prg_lptr [9] = prg_list_create ();
	prg_list_strings_append (prg_lptr [9], 
		"/* Obtain name of script file from the process' attribute. */ ",
		"op_ima_obj_attr_get (op_id_self (), \"script name\", script_name); ",
		"",
		"/* Create and init list to hold failure/recovery instructions. */",
		"event_list_ptr = op_prg_list_create ();   ",
		"",
		"/* Load the file contents into a list. */",
		"line_list_ptr = op_prg_gdf_read (script_name);",
		"",
		"/* Loop through the lines of the list and parse each line. */ ",
		"list_size = op_prg_list_size (line_list_ptr); ",
		"for (i = 0; i < list_size; i++) ",
		"  { ",
		"  /* Obtain the i_th line in the file. */ ",
		"  string = op_prg_list_access (line_list_ptr, i); ",
		"",
		"  /* Decompose the line in to fields. */ ",
		"  field_list_ptr = op_prg_str_decomp (string, \" ,/\\t\"); ",
		"",
		"  /* If the line does not have three fields or starts with '#' */ ",
		"  /* then skip it and try the next. */ ",
		"  if (op_prg_list_size (field_list_ptr) != 3) ",
		"      goto dealloc; ",
		"  field0 = op_prg_list_access (field_list_ptr, 0); ",
		"  if (field0 [0] == '#') goto dealloc; ",
		"",
		"",
		"  /* Allocate a structure to hold the event instruction. */ ",
		"  inst_ptr = (Script_Inst*) op_prg_mem_alloc (sizeof (Script_Inst)); ",
		"",
		"  /* Fill in the instruction. */ ",
		"  inst_ptr->time = atof (field0); ",
		"  inst_ptr->user_id = atoi (op_prg_list_access (field_list_ptr, 1)); ",
		"  field2 = op_prg_list_access (field_list_ptr, 2); ",
		"  if (strcmp (\"failure\", field2) == 0) ",
		"    inst_ptr->type = FAIL_CODE; ",
		"  else inst_ptr->type = RECOVER_CODE; ",
		"",
		"  /* Place the instruction on the end of the list. */ ",
		"  op_prg_list_insert (event_list_ptr, inst_ptr, OPC_LISTPOS_TAIL); ",
		"",
		"  /* Deallocate the elements in the list and then the list itself. */ ",
		"  dealloc: ",
		"  op_prg_list_free (field_list_ptr); ",
		"  op_prg_mem_free (field_list_ptr); ",
		"  } ",
		" ",
		"/* Deallocate the elements in the list and then the list itself. */ ",
		"op_prg_list_free (line_list_ptr); ",
		"op_prg_mem_free (line_list_ptr); ",
		PRGC_NIL);

	Ema_Object_Attr_Set (model_id, obj [7], 
		"name",                 COMP_CONTENTS, "init",
		"enter execs",          COMP_CONTENTS, prg_lptr [9],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [8],
		"initial",              COMP_TOGGLE,   EMAC_ENABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [9]' */
	Ema_Object_Attr_Set (model_id, obj [9], 
		"name",                 COMP_CONTENTS, "idle",
		"position",             COMP_CONTENTS, obj [10],
		"initial",              COMP_TOGGLE,   EMAC_DISABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [11]' */
	/* create and init prg list 'prg_lptr [13]' */
	prg_lptr [13] = prg_list_create ();
	prg_list_strings_append (prg_lptr [13], 
		"/* This process just received a self intrpt that signals a failure */ ",
		"/* or recovery action. Obtain the top instruction from the list. */ ",
		"inst_ptr = (Script_Inst*) op_prg_list_remove (event_list_ptr, OPC_LISTPOS_HEAD); ",
		"",
		"/* Convert user ID to object ID. */ ",
		"object_id = user_id_to_object_id_convert ",
		"                             (inst_ptr->user_id); ",
		"",
		"/* Set the object's \"condition\" attribute to the specified value. */ ",
		"if (inst_ptr->type == FAIL_CODE) ",
		"   op_ima_obj_attr_set (object_id, \"condition\", ",
		"                                 OPC_BOOLINT_DISABLED); ",
		"else ",
		"   op_ima_obj_attr_set (object_id, \"condition\",",
		"                                  OPC_BOOLINT_ENABLED); ",
		"",
		"/* Deallocate instruction. */ ",
		"op_prg_mem_free (inst_ptr); ",
		"",
		"/* Transition to next state, where next interrupt is scheduled. */ ",
		PRGC_NIL);

	Ema_Object_Attr_Set (model_id, obj [11], 
		"name",                 COMP_CONTENTS, "intr",
		"enter execs",          COMP_CONTENTS, prg_lptr [13],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [12],
		"initial",              COMP_TOGGLE,   EMAC_DISABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [13]' */
	/* create and init prg list 'prg_lptr [15]' */
	prg_lptr [15] = prg_list_create ();
	prg_list_strings_append (prg_lptr [15], 
		"/* Obtain the next instruction from the list. */ ",
		"inst_ptr = (Script_Inst*) op_prg_list_access (event_list_ptr, OPC_LISTPOS_HEAD); ",
		"",
		"/* Schedule a self interrupt for the time. */ ",
		"op_intrpt_schedule_self (inst_ptr->time, 0); ",
		PRGC_NIL);

	Ema_Object_Attr_Set (model_id, obj [13], 
		"name",                 COMP_CONTENTS, "sche",
		"enter execs",          COMP_CONTENTS, prg_lptr [15],
		"status",               COMP_TOGGLE,   EMAC_ENABLED,
		"position",             COMP_CONTENTS, obj [14],
		"initial",              COMP_TOGGLE,   EMAC_DISABLED,
		EMAC_EOL);


	/* assign attrs for object 'obj [15]' */
	Ema_Object_Attr_Set (model_id, obj [15], 
		"name",                 COMP_CONTENTS, "tr_8",
		"condition",            COMP_CONTENTS, "",
		"condition",            COMP_INTENDED, EMAC_DISABLED,
		"executive",            COMP_CONTENTS, "",
		"executive",            COMP_INTENDED, EMAC_DISABLED,
		"dest state",           COMP_CONTENTS, obj [13],
		"src state",            COMP_CONTENTS, obj [7],
		"color",                COMP_CONTENTS, 63,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [16],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [17],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [18],
		"label pos",            COMP_CONTENTS, obj [19],
		EMAC_EOL);


	/* assign attrs for object 'obj [20]' */
	Ema_Object_Attr_Set (model_id, obj [20], 
		"name",                 COMP_CONTENTS, "tr_10",
		"condition",            COMP_CONTENTS, "",
		"condition",            COMP_INTENDED, EMAC_DISABLED,
		"executive",            COMP_CONTENTS, "",
		"executive",            COMP_INTENDED, EMAC_DISABLED,
		"dest state",           COMP_CONTENTS, obj [9],
		"src state",            COMP_CONTENTS, obj [13],
		"color",                COMP_CONTENTS, 63,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [21],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [22],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [23],
		"label pos",            COMP_CONTENTS, obj [24],
		EMAC_EOL);


	/* assign attrs for object 'obj [25]' */
	Ema_Object_Attr_Set (model_id, obj [25], 
		"name",                 COMP_CONTENTS, "tr_11",
		"condition",            COMP_CONTENTS, "default",
		"executive",            COMP_CONTENTS, "",
		"executive",            COMP_INTENDED, EMAC_DISABLED,
		"dest state",           COMP_CONTENTS, obj [9],
		"src state",            COMP_CONTENTS, obj [9],
		"color",                COMP_CONTENTS, 63,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [26],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [27],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [28],
		"path",                 COMP_ARRAY_CONTENTS (3), obj [29],
		"path",                 COMP_ARRAY_CONTENTS (4), obj [30],
		"label pos",            COMP_CONTENTS, obj [31],
		EMAC_EOL);


	/* assign attrs for object 'obj [32]' */
	Ema_Object_Attr_Set (model_id, obj [32], 
		"name",                 COMP_CONTENTS, "tr_13",
		"condition",            COMP_CONTENTS, "",
		"condition",            COMP_INTENDED, EMAC_DISABLED,
		"executive",            COMP_CONTENTS, "",
		"executive",            COMP_INTENDED, EMAC_DISABLED,
		"dest state",           COMP_CONTENTS, obj [13],
		"src state",            COMP_CONTENTS, obj [11],
		"color",                COMP_CONTENTS, 63,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [33],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [34],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [35],
		"label pos",            COMP_CONTENTS, obj [36],
		EMAC_EOL);


	/* assign attrs for object 'obj [37]' */
	Ema_Object_Attr_Set (model_id, obj [37], 
		"name",                 COMP_CONTENTS, "tr_15",
		"condition",            COMP_CONTENTS, "ARRIVAL",
		"executive",            COMP_CONTENTS, "",
		"executive",            COMP_INTENDED, EMAC_DISABLED,
		"dest state",           COMP_CONTENTS, obj [11],
		"src state",            COMP_CONTENTS, obj [9],
		"color",                COMP_CONTENTS, 63,
		"path",                 COMP_ARRAY_CONTENTS (0), obj [38],
		"path",                 COMP_ARRAY_CONTENTS (1), obj [39],
		"path",                 COMP_ARRAY_CONTENTS (2), obj [40],
		"label pos",            COMP_CONTENTS, obj [41],
		EMAC_EOL);


	/* assign attrs for object 'obj [8]' */
	Ema_Object_Attr_Set (model_id, obj [8], 
		"x",                    COMP_CONTENTS, (double) 90,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [10]' */
	Ema_Object_Attr_Set (model_id, obj [10], 
		"x",                    COMP_CONTENTS, (double) 450,
		"y",                    COMP_CONTENTS, (double) 270,
		EMAC_EOL);


	/* assign attrs for object 'obj [12]' */
	Ema_Object_Attr_Set (model_id, obj [12], 
		"x",                    COMP_CONTENTS, (double) 270,
		"y",                    COMP_CONTENTS, (double) 390,
		EMAC_EOL);


	/* assign attrs for object 'obj [14]' */
	Ema_Object_Attr_Set (model_id, obj [14], 
		"x",                    COMP_CONTENTS, (double) 270,
		"y",                    COMP_CONTENTS, (double) 210,
		EMAC_EOL);


	/* assign attrs for object 'obj [16]' */
	Ema_Object_Attr_Set (model_id, obj [16], 
		"x",                    COMP_CONTENTS, (double) 105,
		"y",                    COMP_CONTENTS, (double) 185,
		EMAC_EOL);


	/* assign attrs for object 'obj [17]' */
	Ema_Object_Attr_Set (model_id, obj [17], 
		"x",                    COMP_CONTENTS, (double) 133,
		"y",                    COMP_CONTENTS, (double) 166,
		EMAC_EOL);


	/* assign attrs for object 'obj [18]' */
	Ema_Object_Attr_Set (model_id, obj [18], 
		"x",                    COMP_CONTENTS, (double) 247,
		"y",                    COMP_CONTENTS, (double) 192,
		EMAC_EOL);


	/* assign attrs for object 'obj [19]' */
	Ema_Object_Attr_Set (model_id, obj [19], 
		"x",                    COMP_CONTENTS, (double) 119,
		"y",                    COMP_CONTENTS, (double) 175,
		EMAC_EOL);


	/* assign attrs for object 'obj [21]' */
	Ema_Object_Attr_Set (model_id, obj [21], 
		"x",                    COMP_CONTENTS, (double) 293,
		"y",                    COMP_CONTENTS, (double) 193,
		EMAC_EOL);


	/* assign attrs for object 'obj [22]' */
	Ema_Object_Attr_Set (model_id, obj [22], 
		"x",                    COMP_CONTENTS, (double) 371,
		"y",                    COMP_CONTENTS, (double) 179,
		EMAC_EOL);


	/* assign attrs for object 'obj [23]' */
	Ema_Object_Attr_Set (model_id, obj [23], 
		"x",                    COMP_CONTENTS, (double) 439,
		"y",                    COMP_CONTENTS, (double) 243,
		EMAC_EOL);


	/* assign attrs for object 'obj [24]' */
	Ema_Object_Attr_Set (model_id, obj [24], 
		"x",                    COMP_CONTENTS, (double) 332,
		"y",                    COMP_CONTENTS, (double) 186,
		EMAC_EOL);


	/* assign attrs for object 'obj [26]' */
	Ema_Object_Attr_Set (model_id, obj [26], 
		"x",                    COMP_CONTENTS, (double) 461,
		"y",                    COMP_CONTENTS, (double) 243,
		EMAC_EOL);


	/* assign attrs for object 'obj [27]' */
	Ema_Object_Attr_Set (model_id, obj [27], 
		"x",                    COMP_CONTENTS, (double) 488,
		"y",                    COMP_CONTENTS, (double) 175,
		EMAC_EOL);


	/* assign attrs for object 'obj [28]' */
	Ema_Object_Attr_Set (model_id, obj [28], 
		"x",                    COMP_CONTENTS, (double) 565,
		"y",                    COMP_CONTENTS, (double) 246,
		EMAC_EOL);


	/* assign attrs for object 'obj [29]' */
	Ema_Object_Attr_Set (model_id, obj [29], 
		"x",                    COMP_CONTENTS, (double) 492,
		"y",                    COMP_CONTENTS, (double) 315,
		EMAC_EOL);


	/* assign attrs for object 'obj [30]' */
	Ema_Object_Attr_Set (model_id, obj [30], 
		"x",                    COMP_CONTENTS, (double) 473,
		"y",                    COMP_CONTENTS, (double) 285,
		EMAC_EOL);


	/* assign attrs for object 'obj [31]' */
	Ema_Object_Attr_Set (model_id, obj [31], 
		"x",                    COMP_CONTENTS, (double) 474,
		"y",                    COMP_CONTENTS, (double) 209,
		EMAC_EOL);


	/* assign attrs for object 'obj [33]' */
	Ema_Object_Attr_Set (model_id, obj [33], 
		"x",                    COMP_CONTENTS, (double) 260,
		"y",                    COMP_CONTENTS, (double) 362,
		EMAC_EOL);


	/* assign attrs for object 'obj [34]' */
	Ema_Object_Attr_Set (model_id, obj [34], 
		"x",                    COMP_CONTENTS, (double) 238,
		"y",                    COMP_CONTENTS, (double) 314,
		EMAC_EOL);


	/* assign attrs for object 'obj [35]' */
	Ema_Object_Attr_Set (model_id, obj [35], 
		"x",                    COMP_CONTENTS, (double) 258,
		"y",                    COMP_CONTENTS, (double) 235,
		EMAC_EOL);


	/* assign attrs for object 'obj [36]' */
	Ema_Object_Attr_Set (model_id, obj [36], 
		"x",                    COMP_CONTENTS, (double) 249,
		"y",                    COMP_CONTENTS, (double) 338,
		EMAC_EOL);


	/* assign attrs for object 'obj [38]' */
	Ema_Object_Attr_Set (model_id, obj [38], 
		"x",                    COMP_CONTENTS, (double) 443,
		"y",                    COMP_CONTENTS, (double) 297,
		EMAC_EOL);


	/* assign attrs for object 'obj [39]' */
	Ema_Object_Attr_Set (model_id, obj [39], 
		"x",                    COMP_CONTENTS, (double) 401,
		"y",                    COMP_CONTENTS, (double) 377,
		EMAC_EOL);


	/* assign attrs for object 'obj [40]' */
	Ema_Object_Attr_Set (model_id, obj [40], 
		"x",                    COMP_CONTENTS, (double) 295,
		"y",                    COMP_CONTENTS, (double) 402,
		EMAC_EOL);


	/* assign attrs for object 'obj [41]' */
	Ema_Object_Attr_Set (model_id, obj [41], 
		"x",                    COMP_CONTENTS, (double) 422,
		"y",                    COMP_CONTENTS, (double) 337,
		EMAC_EOL);


	/* assign attrs for object 'obj [0]' */
	Ema_Object_Attr_Set (model_id, obj [0], 
		"name",                 COMP_CONTENTS, "begsim intrpt",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_TOGGLE,
		"value",                COMP_TOGGLE,   EMAC_ENABLED,
		"type",                 COMP_CONTENTS, 2,
		EMAC_EOL);


	/* assign attrs for object 'obj [1]' */
	Ema_Object_Attr_Set (model_id, obj [1], 
		"name",                 COMP_CONTENTS, "endsim intrpt",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_TOGGLE,
		"value",                COMP_TOGGLE,   EMAC_ENABLED,
		"type",                 COMP_CONTENTS, 2,
		EMAC_EOL);


	/* assign attrs for object 'obj [2]' */
	Ema_Object_Attr_Set (model_id, obj [2], 
		"name",                 COMP_CONTENTS, "failure intrpts",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_STRING,
		"value",                COMP_CONTENTS, "network wide",
		"type",                 COMP_CONTENTS, 8,
		EMAC_EOL);


	/* assign attrs for object 'obj [3]' */
	Ema_Object_Attr_Set (model_id, obj [3], 
		"name",                 COMP_CONTENTS, "intrpt interval",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_DOUBLE,
		"value",                COMP_CONTENTS, (double) -1e+100,
		"value",                COMP_INTENDED, EMAC_DISABLED,
		"type",                 COMP_CONTENTS, 3,
		EMAC_EOL);


	/* assign attrs for object 'obj [4]' */
	Ema_Object_Attr_Set (model_id, obj [4], 
		"name",                 COMP_CONTENTS, "priority",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_INTEGER,
		"value",                COMP_CONTENTS, 0,
		"value",                COMP_INTENDED, EMAC_DISABLED,
		"type",                 COMP_CONTENTS, 0,
		EMAC_EOL);


	/* assign attrs for object 'obj [5]' */
	Ema_Object_Attr_Set (model_id, obj [5], 
		"name",                 COMP_CONTENTS, "recovery intrpts",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_STRING,
		"value",                COMP_CONTENTS, "network wide",
		"type",                 COMP_CONTENTS, 8,
		EMAC_EOL);


	/* assign attrs for object 'obj [6]' */
	Ema_Object_Attr_Set (model_id, obj [6], 
		"name",                 COMP_CONTENTS, "super priority",
		"operation",            COMP_CONTENTS, 2,
		"value",                COMP_CONTENTS_TYPE, EMAC_TOGGLE,
		"value",                COMP_TOGGLE,   EMAC_DISABLED,
		"value",                COMP_INTENDED, EMAC_DISABLED,
		"type",                 COMP_CONTENTS, 2,
		EMAC_EOL);








	/* write the model to application-readable form */
	Ema_Model_Write (model_id, "fault_pr");

	}

